import test, { ExecutionContext, ImplementationResult } from 'ava';
import * as fc from 'fast-check';
declare type ArbitraryTuple<Ts extends [any] | any[]> = {
    [P in keyof Ts]: fc.Arbitrary<Ts[P]>;
};
declare type Prop<Ts extends [any] | any[]> = (t: ExecutionContext, ...args: Ts) => ImplementationResult;
export declare function testProp<Ts extends [any] | any[]>(label: string, arbitraries: ArbitraryTuple<Ts>, prop: Prop<Ts>, params?: fc.Parameters<Ts>): void;
export declare namespace testProp {
    const only: <Ts extends any[] | [any]>(label: string, arbitraries: ArbitraryTuple<Ts>, prop: Prop<Ts>, params?: fc.Parameters<Ts> | undefined) => void;
    const failing: <Ts extends any[] | [any]>(label: string, arbitraries: ArbitraryTuple<Ts>, prop: Prop<Ts>, params?: fc.Parameters<Ts> | undefined) => void;
    const skip: <Ts extends any[] | [any]>(label: string, arbitraries: ArbitraryTuple<Ts>, prop: Prop<Ts>, params?: fc.Parameters<Ts> | undefined) => void;
    const serial: <Ts extends any[] | [any]>(label: string, arbitraries: ArbitraryTuple<Ts>, prop: Prop<Ts>, params?: fc.Parameters<Ts> | undefined) => void;
}
export { test, fc };
